<!-- main app container -->
<div class="container">
  <h1 style="text-align: center;">Student Data List</h1>
  <div>
    <button type="button" class="btn btn-info btn-lg" data-toggle="modal" (click)="resetForm()" data-target="#addModal">Add Student</button>
    <button type="button" style="position: absolute;top:0;right:0;margin-top: 1px;margin-right: 2px;" class="btn btn-danger btn-lg" (click)="logout()">Logout</button>
  </div>
  <br>
  <div class="row">
    <input type="text" class="form-control" name="searchString" placeholder="Search student name..." [(ngModel)]="searchText"/>
  </div>
  <br>
  <div class="card text-center m-3">
    <div class="card-body">
      <table id="students">
        <thead>
          <tr>
            <th>Roll No.</th>
            <th>Name</th>
            <th>Branch</th>
            <th>Year</th>
            <th>Edit</th>
            <th>Delete</th>
          </tr>
        </thead>
        <tbody>
          <tr *ngFor="let item of pageOfItems | searchFilter: 'name' : searchText">
            <td>{{item.rollno}}</td>
            <td>{{item.name}}</td>
            <td>{{item.branch}}</td>
            <td>{{item.year}}</td>
            <td align="center"><button class='btn btn-info btn-xs btn-edit' (click) = "openModal(item)" data-toggle="modal" data-target="#editModal">Edit</button></td>
            <td align="center"><button class='btn btn-danger btn-xs btn-delete' (click) = "delStudent(item._id,item.name)">Delete</button></td>
          </tr>
        </tbody>
      </table>
    </div>
    <div class="card-footer pb-0 pt-3">
      <ul *ngIf="pager.pages && pager.pages.length" class="pagination">
        <li [ngClass]="{disabled:pager.currentPage === 1}" class="page-item first-item">
          <a routerLink [queryParams]="{ page: 1 }" (click)="pressed(1)" class="page-link">First</a>
        </li>
        <li [ngClass]="{disabled:pager.currentPage === 1}" class="page-item previous-item">
          <a routerLink [queryParams]="{ page: pager.currentPage - 1 }" (click)="pressed(pager.currentPage - 1)" class="page-link">Previous</a>
        </li>
        <li *ngFor="let page of pager.pages" [ngClass]="{active:pager.currentPage === page}" class="page-item number-item">
          <a routerLink [queryParams]="{ page: page }" (click)="pressed(page)" class="page-link">{{page}}</a>
        </li>
        <li [ngClass]="{disabled:pager.currentPage === pager.totalPages}" class="page-item next-item">
          <a routerLink [queryParams]="{ page: pager.currentPage + 1 }" (click)="pressed(pager.currentPage + 1)" class="page-link">Next</a>
        </li>
        <li [ngClass]="{disabled:pager.currentPage === pager.totalPages}" class="page-item last-item">
          <a routerLink [queryParams]="{ page: pager.totalPages }" (click)="pressed(pager.totalPages)" class="page-link">Last</a>
        </li>
      </ul>
    </div>
  </div>
  <div id="addModal" [hidden]="hideModal" class="{{hideModal}} ? modal fade out : modal fade" role="dialog">
    <div class="modal-dialog">
      <!-- Modal content-->
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal">&times;</button>
          <h4 class="modal-title">Add Student</h4>
        </div>
        <div class="row">
          <div class="col-md-6 offset-md-3">
            <div class="modal-body">
              <form [formGroup]="studForm" (ngSubmit)="addStudent()">
                <div class="form-group">
                  <label>Roll no. (*)</label>
                  <input type="text" formControlName="rollno" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.rollno.errors }" />
                  <div *ngIf="submitted && f.rollno.errors" class="invalid-feedback">
                    <div *ngIf="f.rollno.errors.required" style="color: red">Roll No. is required</div>
                  </div>
                  <label>Student Name (*)</label>
                  <input type="text" formControlName="name" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.name.errors }" />
                  <div *ngIf="submitted && f.name.errors" class="invalid-feedback">
                    <div *ngIf="f.name.errors.required" style="color: red">Student name is required</div>
                  </div>
                  <label>Email (*)</label>
                  <input type="text" formControlName="email" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.email.errors }" />
                  <div *ngIf="submitted && f.email.errors" class="invalid-feedback">
                      <div *ngIf="f.email.errors.required" style="color: red">Email is required</div>
                      <div *ngIf="f.email.errors.email" style="color: red">Email must be a valid email address</div>
                  </div>
                  <label>Phone No. (*)</label>
                  <input type="text" formControlName="phone" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.phone.errors }" />
                  <div *ngIf="submitted && f.phone.errors" class="invalid-feedback">
                    <div *ngIf="f.phone.errors.required" style="color: red">Phone No. is required</div>
                  </div>
                  <label>Branch (*)</label>
                  <select formControlName="branch" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.branch.errors }" >
                    <option value="computer">Computer</option>
                    <option value="civil">Civil</option>
                    <option value="mechanical">Mechanical</option>
                    <option value="electrical">Electrical</option>
                    <option value="automobile">Automobile</option>
                  </select>
                  <div *ngIf="submitted && f.branch.errors" class="invalid-feedback">
                    <div *ngIf="f.branch.errors.required" style="color: red">Branch is required</div>
                  </div>
                  <label>Year (*)</label>
                  <select formControlName="year" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.year.errors }" >
                    <option value="1">1</option>
                    <option value="2">2</option>
                    <option value="3">3</option>
                    <option value="4">4</option>
                  </select>
                  <div *ngIf="submitted && f.year.errors" class="invalid-feedback">
                    <div *ngIf="f.year.errors.required" style="color: red">Year is required</div>
                  </div>
                  <label>Gender</label>
                  <select formControlName="gender" class="form-control">
                    <option value="male">Male</option>
                    <option value="female">Female</option>
                    <option value="others">Others</option>
                  </select>
                  <label>Age</label>
                  <input type="text" formControlName="age" class="form-control"/>
                  <label>City</label>
                  <input type="text" formControlName="city" class="form-control"/>
                </div>
                <div class="form-group">
                  <button class="btn btn-primary">Add Student</button>
                </div>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div id="editModal" [hidden]="hideModal" class="{{hideModal}} ? modal fade out : modal fade" role="dialog">
    <div class="modal-dialog">
      <!-- Modal content-->
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal">&times;</button>
          <h4 class="modal-title">Add Student</h4>
        </div>
        <div class="row">
          <div class="col-md-6 offset-md-3">
            <div class="modal-body">
              <form [formGroup]="studForm" (ngSubmit)="updateStudent()">
                <div class="form-group">
                  <label>Roll no. (*)</label>
                  <input type="text" formControlName="rollno" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.rollno.errors }" />
                  <div *ngIf="submitted && f.rollno.errors" class="invalid-feedback">
                    <div *ngIf="f.rollno.errors.required" style="color: red">Roll No. is required</div>
                  </div>
                  <label>Student Name (*)</label>
                  <input type="text" formControlName="name" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.name.errors }" />
                  <div *ngIf="submitted && f.name.errors" class="invalid-feedback">
                    <div *ngIf="f.name.errors.required" style="color: red">Student name is required</div>
                  </div>
                  <label>Email (*)</label>
                  <input type="text" formControlName="email" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.email.errors }" />
                  <div *ngIf="submitted && f.email.errors" class="invalid-feedback">
                    <div *ngIf="f.email.errors.required" style="color: red">Email is required</div>
                    <div *ngIf="f.email.errors.email" style="color: red">Email must be a valid email address</div>
                  </div>
                  <label>Phone No. (*)</label>
                  <input type="text" formControlName="phone" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.phone.errors }" />
                  <div *ngIf="submitted && f.phone.errors" class="invalid-feedback">
                    <div *ngIf="f.phone.errors.required" style="color: red">Phone No. is required</div>
                  </div>
                  <label>Branch (*)</label>
                  <select formControlName="branch" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.branch.errors }" >
                    <option value="computer">Computer</option>
                    <option value="civil">Civil</option>
                    <option value="mechanical">Mechanical</option>
                    <option value="electrical">Electrical</option>
                    <option value="automobile">Automobile</option>
                  </select>
                  <div *ngIf="submitted && f.branch.errors" class="invalid-feedback">
                    <div *ngIf="f.branch.errors.required" style="color: red">Branch is required</div>
                  </div>
                  <label>Year (*)</label>
                  <select formControlName="year" class="form-control" [ngClass]="{ 'is-invalid': submitted && f.year.errors }" >
                    <option value="1">1</option>
                    <option value="2">2</option>
                    <option value="3">3</option>
                    <option value="4">4</option>
                  </select>
                  <div *ngIf="submitted && f.year.errors" class="invalid-feedback">
                    <div *ngIf="f.year.errors.required" style="color: red">Year is required</div>
                  </div>
                  <label>Gender</label>
                  <select formControlName="gender" class="form-control">
                    <option value="male">Male</option>
                    <option value="female">Female</option>
                    <option value="others">Others</option>
                  </select>
                  <label>Age</label>
                  <input type="text" formControlName="age" class="form-control"/>
                  <label>City</label>
                  <input type="text" formControlName="city" class="form-control"/>
                </div>
                <div class="form-group">
                  <button class="btn btn-primary">Update Student</button>
                </div>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>